#####################################################################
#     mkbdf.awk  for make tategaki kanji_bdf font                   #
#                                                                   #
#  gawk  -f mkbdf.awk jiskan24.bdf > T_jiskan24.bdf                 #
#  gawk  -f mkbdf.awk jiskan16.bdf > T_jiskan16.bdf                 #
#  gawk  -f mkbdf.awk k14.bdf      > T_k14.bdf                      #
#                                                                   #
#  Copyright (c) Fukai Yoshiharu 1996.07.01                         #
#  Copyright (c) Fukai Yoshiharu 1996.05.14                         #
#  Copyright (c) Fukai Yoshiharu 1995.12.22                         #
#               <PED00251@niftyserve.or.jp>                         #
#####################################################################

BEGIN{
	Hexarray="0123456789abcdef";

	Jiscode["2122-2125"]="S";  # Shift bitmap right-up kutouten

	Jiscode["2421"]="S";       # sokuon hiragana  
	Jiscode["2423"]="S";
	Jiscode["2425"]="S";
	Jiscode["2427"]="S";
	Jiscode["2429"]="S";
	Jiscode["2443"]="S";
	Jiscode["2463"]="S";
	Jiscode["2465"]="S";
	Jiscode["2467"]="S";
	Jiscode["246e"]="S";

	Jiscode["2521"]="S";       # sokuon katakana 
	Jiscode["2523"]="S";
	Jiscode["2525"]="S";
	Jiscode["2527"]="S";
	Jiscode["2529"]="S";
	Jiscode["2543"]="S";
	Jiscode["2563"]="S";
	Jiscode["2565"]="S";
	Jiscode["2567"]="S";
	Jiscode["256e"]="S";
	Jiscode["2575"]="S";
	Jiscode["2576"]="S";

	Jiscode["2127-2128"]="R"; # Rotate 90deg clock wise for TATEGAKI
	Jiscode["2130-2132"]="R"; 
	Jiscode["213c-215b"]="R"; 
	Jiscode["215d-2167"]="R"; 
	Jiscode["2261-2264"]="R"; 
	Jiscode["223a-224a"]="R"; 
	Jiscode["224d-224e"]="R"; 
	Jiscode["222a-222e"]="R"; 

#	Jiscode["2341-235a"]="R"; 
#	Jiscode["2361-237a"]="R";

Flag=""; N=0; XW=YW=0; Padbit = 0;
}

{

	
	if($1 ~ /^BBX/ && ($2 != $3) ){
		print "Not square  font !!";
		exit;
	}

	if($1 ~ /^STARTCHAR/ ){
		Flag=codecheck($2);
		Buf = ""; YW = 0;
	}
         
	if( Flag == "S" || Flag == "R" ){

		if( $0 ~ /^[0-9a-fA-F]+$/){
			N=length($0);
			YW++;
			$0 = tolower($0);
			Buf = Buf $0;
		}else if( $0 ~ /^ENDCHAR/ ){
			XW=N*4; Padbit = XW - YW;
			YW = YW + Padbit;

			if(Flag == "S"){
				for( iii=0; iii < Padbit * N; iii++)
					Buf = Buf  "0";
			      output(shift(Buf));
			}else{
				for( iii=0; iii < Padbit * N; iii++)
					Buf = "0" Buf;
			  output(rot_cw90(Buf));
			}	
			print $0;

		}else print $0;	

	}else print $0
}

func inttobit(x,   bit,i) {
		bit="";
	for(i=8; i >= 1 ;i/=2){
		int(x/i) == 1 ? bit = bit "1" : bit = bit "0"
		x %= i;
	}
	return bit;
}	

func hextoint(h) { return match(Hexarray,h)-1 }

func rot_cw90(h,   i,j,x,y,bitpat,tmp) {
	j=length(h); bitpat = tmp = "";

	for(i=1;i<= j; i++)
              bitpat = bitpat  inttobit(hextoint(substr(h,i,1)));

	for(x=1;x<=XW;x++)
		for(y=YW;y>=1; y--)
			tmp = tmp substr(bitpat,(y-1)*XW+x,1);

	bitpat =""; 
	for(x=0;x < int(length(tmp)/4); x++){
	    bitpat = bitpat bittohex(substr(tmp,x*4+1,4));
	}
	return bitpat
}
#########

func shift(h,   i,j,x,y,bitpat,tmp) {
	j=length(h); bitpat = tmp = "";

	for(i=1;i<= j; i++)
              bitpat = bitpat  inttobit(hextoint(substr(h,i,1)));


#left/rigth margin
  Bx=Lx=Lxk=0;
	for(x=1;x<=XW;x++)
		for(y=YW;y>=1; y--){
			 tmp = tmp substr(bitpat,(y-1)*XW+x,1)
			if(length(tmp) == XW){
			  if(index(tmp ,"1")==0)
				Lx++;
			  else { 
				Bx++; Lxk=Lx;
			  }
			tmp = "";
			}
                }
	
# Lxk:left margin;
# XW - Bx - Lxk : right margin; 
#	Shx = (XW - Bx - Lxk) - Lxk;
#	if(Shx<0) Shx = 0;

#upper/bottom margin
Shy=Yup=Yupk=By=0;
	for(x=1;x < XW*YW ; x+=XW){
	    if(index(substr(bitpat,x,XW),"1")==0)
		Yup++;
	    else {By++; Yupk=Yup;}
	}

# Yupk: top margin;
# YW - By - Yupk: bottom margin;
#	Shy = Yupk - (YW - By - Yupk);
#	if(Shy<0) Shy = 0;

	Shx = (XW - Bx - Lxk) - (YW - By - Yupk);
	if(Shx<0) Shx = 0;

	Shy = Yupk - Lxk;
	if(Shy<0) Shy = 0;

# x shift
	for(x=1;x < XW*YW ; x+=XW){
	 tmp = tmp   substr(substr(bitpat,x,XW),XW-Shx+1,Shx) substr(substr(bitpat,x,XW),1,XW-Shx) 
	}


#y shift
	bitpat = tmp;
	tmp=j="";


	for(x = Shy*YW+1; x < XW*YW ; x += XW) 
			 tmp = tmp substr(bitpat,x,XW)

	for(x = 1; x < Shy * XW ; x += XW) 
			 tmp = tmp substr(bitpat,x,XW)

	bitpat =""; 
	for(x=0;x < int(length(tmp)/4); x++){
	    bitpat = bitpat bittohex(substr(tmp,x*4+1,4));
	}
	return bitpat     # return hex
}




## 4bit => 1hex		
func bittohex(bit,	i,j){

		j=0; 
		for(i=1;i<=4;i++){
			if(substr(bit,i,1)==1){
		            if(i==1)      j+=8
		            else if(i==2) j+=4
		            else if(i==3) j+=2
		            else if(i==4) j+=1
			}
	        }
	return substr(Hexarray,j+1,1)
}

func output(h,  i){
	for(i=1;i <= (YW - Padbit)*N ;i+=N)
		printf("%s\n",substr(h,i,N))
}

func codecheck(jis, x,a){
	jis = tolower(jis);

	       for (x in Jiscode){
			if( jis == x ) return  Jiscode[jis];

		if( length(x) == 9){ #hhhh-hhhh=9
			split(x,a,"-");
			if( jis >= tolower(a["1"]) && jis <= tolower(a["2"]))
				return Jiscode[x]; 
       		} 
	      }
	return "";
}

