/*----------------------------------------------------------
  vtp_sjis.c
  TATEGAKI PAGER for KANJI TEXT
  Copyright (c) Fukai Yoshiharu 1996.07.13
  Copyright (c) Fukai Yoshiharu 1996.06.01
  Copyright (c) Fukai Yoshiharu 1996.03.24
  Copyright (c) Fukai Yoshiharu 1996.03.20
  Copyright (c) Fukai Yoshiharu 1996.01.08
  Copyright (c) Fukai Yoshiharu 1996.01.04
  Copyright (c) Fukai Yoshiharu 1995.12.29
  Copyright (c) Fukai Yoshiharu 1995.12.22
  Copyright (c) Fukai Yoshiharu 1995.06.25
                                <PED00251@niftyserve.or.jp>
-----------------------------------------------------------*/
#ifdef SUNOS
#include <sys/ioctl.h>
#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#else
#include <stdio.h>
#ifdef LINUX
#include <sys/ioctl.h>
#include <bsd/sgtty.h>
#else /* for FreeBSD default */
#include <sys/ioctl_compat.h>
#endif
#include <termios.h>
#include <ctype.h>
#include <unistd.h>
#endif

#define CR 		0x0d
#define LF 		0x0a
#define ESC 		0x1b
#define TAB 		0x09
#define BACK_SPACE 	0x08
#define MAX_PAGES 	5000
#define S_STR_SIZE 	20
#define KETA_SU       	5
#define NOT_FOUND       (-1)
#define MIN_L	 	2	
#define MIN_C	 	2

#define BOOKMARK_FILE   ".bookmark"

#define KEISEN 1
#define OIKOMI 2
#define SERIFU 4
#define KMARK  8
#define HAN2ZEN  16

typedef unsigned char JC;

/* KANJI CODE SELECT */
/* for EUC */
#ifdef EUC
#define iskanji(c) (((c)>=0xa1 && (c)<=0xfe))
#else 
/* for default dirty SHIFT_JIS */
#define iskanji(c) ((c)>=0x81 && (c)<=0x9F || (c)>=0xE0 && (c)<=0xFC)
#endif

enum{ KANJI, ASCII, NEWLINE, ON, OFF, QUIT, FORWARD, REVERSE, ALL, CLS_TAIL };

JC Last[3];
JC *Headkin[] = 
{
 "A", "B", "C", "D", "`", "[","H","I","E","U","V","T","S","R","X",
 "j", "l", "n", "p", "r", "t", "v", "x", "z", 
 "", "", "", "", "", "", "", "", "", 
 "@", "D", "F", "H", "", "", "", "B", "b", NULL
};

JC *Tailkin[] = 
{
 "i", "k", "m", "o", "q", "s", "u", "w", "y", NULL
};

JC *Kuten[] = 
{
 "B", "D", NULL
};

JC *Serifu_begin[] = 
{
 "u", "w", NULL
};
JC *Serifu_end[] = 
{
 "v", "x", NULL
};

JC *Indent[] = 
{
 "@", " ", "u", "w", NULL
};

JC *Zenkaku[] = 
{
       "I", "", "", "", "", "", "f",
 "i", "j", "", "{", "C", "|", "D", "^",
 "O", "P", "Q", "R", "S", "T", "U", "V",
 "W", "X", "F", "G", "", "", "", "H",
 "", "`", "a", "b", "c", "d", "e", "f",
 "g", "h", "i", "j", "k", "l", "m", "n",
 "o", "p", "q", "r", "s", "t", "u", "v",
 "w", "x", "y", "m", "", "n", "O", "Q",
 "@", "", "", "", "", "", "", "",
 "", "", "", "", "", "", "", "",
 "", "", "", "", "", "", "", "",
 "", "", "", "o", "b", "p", "`"
};
int X_pos, Y_pos, Page, Maxpage, Max_l, Max_c,PageB;
int St_x, St_y, Step_x, Step_y, X_limit, Y_limit, Offset;
int Options, Dispsw;
FILE *Fpi,*Fpb;
long P_ary[MAX_PAGES+1], S_ptr;
int S_mode, S_x, S_y, F_flag;
char Bname[1024],Fname[256];

typedef struct bookmark {
	struct bookmark *left, *right;
	char *fname;
	long pos;
} *bookmarkptr;
bookmarkptr Anchor = NULL;
bookmarkptr add_book();

main(ac, av)
int ac;
char *av[];
{
         int c;
	char *str;
	struct sgttyb sglast, sgnew;
	struct tchars tclast, tcnew;
	struct winsize foowin;

	Page = 1; Options = 0;Offset = 0;
	S_ptr = 0L;F_flag = OFF;
	Max_l = Max_c = 0;

	while( --ac > 0 && (*++av)[0] == '-')
	  for(str = av[0]+1; *str != '\0' && !(*str>='0' && *str<='9'); str++)
			switch (*str){
			case 'W':
				Max_c = atoi(str+1);
				break;
			case 'H':
				Max_l = atoi(str+1);
				break;
			case 'g':
				Options |= KEISEN;
				break;
			case 'o':
				Options |= OIKOMI;
				break;
			case 's':
				Options |= SERIFU;
				break;
			case 'k':
				Options |= KMARK;
				break;
			case 'z':
				Options |= HAN2ZEN;
				break;
			default :
				printf("illegal option %c \n", *str);
				ac = 0;
				break;
			}

	if(ac == 1){
		 if((Fpi = fopen(*av, "r")) == 0){
			printf("%s is not found\n", *av);
				exit();
                 }
	}else {
		usage();
		exit();
	}
/**************************************************/
     if(getenv("HOME") == NULL)
	    strcpy(Bname,BOOKMARK_FILE);
     else{
	strcpy(Bname,getenv("HOME"));
	strcat(Bname,"/");
	strcat(Bname,BOOKMARK_FILE);
     }

     if(strrchr(*av,'/') == NULL) strcpy(Fname,*av);
     else strcpy(Fname,strrchr(*av,'/')+1);
/**************************************************/

	ioctl(0, TIOCGWINSZ, &foowin);

	if(Max_l <= 0) Max_l = foowin.ws_row;
	if(Max_c <= 0) Max_c = foowin.ws_col;

     if(foowin.ws_row > MIN_L && Max_l > foowin.ws_row) Max_l = foowin.ws_row;
     if(foowin.ws_col > MIN_C && Max_c > foowin.ws_col) Max_c = foowin.ws_col;

	if(Max_l <= MIN_L || Max_c <= MIN_C){
           printf("Window is too small or winsize function unsupported.\n");
	   printf("Try:\n vtp -Wnn -Hnn foobar.txt\n");
	   exit();
	}	

	if( Options & KEISEN ){
		int tmp_c = Max_c;
		Max_c = (Max_c  - 6)/4 * 4 + 6;
		St_x = Max_c - 3; 
		Step_x = 4;
		X_limit = 3;
		Max_l = (Max_l - 1 - 3)/2 * 2 + 4;
		St_y = 2;	
		Step_y = 2;
		Y_limit = Max_l - 2;
	
        	Offset = (tmp_c - Max_c)/2;
	}else{
		int tmp_c = Max_c;
		Max_c = (Max_c  - 4)/3 * 3 + 4;
		St_x = Max_c - 2; /* right margin = 2 */
		St_y = 2;	  /* top margin = 2 */ 
		Step_x = 3;
		Step_y = 1;
		X_limit = 1;
		Y_limit = Max_l - 2;
        	Offset = (tmp_c - Max_c)/2;
	}



	ioctl(0, TIOCGETP, &sglast);
	ioctl(0, TIOCGETC, &tclast);
	 sgnew = sglast;
	sgnew.sg_flags &= ~ECHO;
	sgnew.sg_flags |= CBREAK;

	tcnew = tclast;
	tcnew.t_intrc = -1;

	ioctl(0, TIOCSETP, &sgnew);
	ioctl(0, TIOCSETC, &tcnew);

        clstxt(ALL);
	Dispsw = ON;
	if(Options & KEISEN ) kdraw();
	Dispsw = OFF;

	while(c != EOF){
		if(Page>MAX_PAGES){ 
                  printf("\nToo many Pages. %d Pages available!\n", MAX_PAGES);
			ioctl(0, TIOCSETP, &sglast);
			ioctl(0, TIOCSETC, &tclast);
			exit();
		}
	P_ary[Page] = ftell(Fpi);
		for (X_pos =  St_x ; X_pos >= X_limit ; X_pos -= Step_x){
		      for(Y_pos = St_y ; Y_pos <= Y_limit ; Y_pos += Step_y){
			  if((c = disp()) == NEWLINE) break;
		      }
		 }
	Page++;
	}

		fseek(Fpi, 0L, SEEK_END);
		 P_ary[Page] = ftell(Fpi);

	Maxpage = Page-1;

	Page =  read_book();
	fseek(Fpi,  P_ary[Page], SEEK_SET);
	Dispsw = ON;

	while(1){
		for (X_pos =  St_x ; X_pos >= X_limit ; X_pos -= Step_x){
		      for(Y_pos = St_y ; Y_pos <= Y_limit ; Y_pos += Step_y){
				locate(X_pos + Offset, Y_pos);
			  if(disp() == NEWLINE) break;
		      }
		 }

		if(prompt() == QUIT) {
			clstxt(ALL);
			ioctl(0, TIOCSETP, &sglast);
			ioctl(0, TIOCSETC, &tclast);

			 if((Fpb = fopen(Bname, "w")) == 0){
				printf("Can't write bookmark to %s.\n", Bname);
			 }else{
				Anchor = add_book(Anchor,Fname, P_ary[Page]);
				printbook(Anchor);	
			 }
			usage();
			exit();
		}

		if(Options & KEISEN) kcls();
		else clstxt(ALL);

	}
}

disp()
{
	int c, c2, c3;
static  JC current[3], next[3], nextnext[3];

dirty:
	c = kgetc(current);
          switch  (c){
            case EOF:   return EOF;
            case ASCII: 
			kput(current);
                       break;
            case NEWLINE : 
                        if(Options & OIKOMI){
                                if(islastcr()){
                                        kaigyo();return NEWLINE; 
				}

                                if(cmp(Last, Kuten) && Y_pos != St_y ){
                                        Last[0] = 'a';
                                         kaigyo();return NEWLINE;
                                }else{
				     if((c2 = kgetc(next)) == EOF) return EOF;
				     else if(c2 == KANJI){
				              if(cmp(next, Indent)){
                                                   if(Y_pos == St_y){
							kput(next);
                                                        break;
                                                    }else{
							kungetc(KANJI);
							kaigyo();return NEWLINE;
                                   	       	    }
						}else{
							kungetc(KANJI);
							 goto dirty;
						} 
				      }else if( c2 == ASCII){
					if(next[0] == ' '){
						if( Y_pos == St_y){
							 kput(next);
							break;
						}else{
							kungetc(ASCII);
							kaigyo();return NEWLINE;
						}
					}else{
						kungetc(ASCII);
					         goto dirty;
					}
				      }else if(c2 == NEWLINE){
						kungetc(ASCII);
             					 kaigyo();return NEWLINE;
				      }
				}


		        }else kaigyo();return NEWLINE;
            case KANJI :
		if(Y_pos == Y_limit-1){
			  if((c2 = kgetc(next)) == EOF){
			      kput(current);
			      return EOF;
			  }else{ 
			      if((c3 = kgetc(nextnext)) == EOF){
			      		kput(current);
				if( c2 == ASCII || c2 == NEWLINE ){
					kungetc(ASCII);
					return EOF;
				}else{
					kungetc(KANJI);
					return EOF;
			        }
			      }
			
			     if(   c2 == NEWLINE && c3 == NEWLINE
				|| c2 == ASCII && c3 == NEWLINE
				|| c2 == ASCII && c3 == ASCII
				|| c2 == NEWLINE && c3 == ASCII){
			      		kput(current);
					kungetc(ASCII);
					kungetc(ASCII);
					break;
			     }else if((c2 == KANJI 
					&& (c3 == ASCII || c3 == NEWLINE))
				       || (c2 == ASCII || c2 == NEWLINE)
							 && c3 == KANJI){
			      		kput(current);
					kungetc(KANJI);
					kungetc(ASCII);
					break;
		             }else{
				if((cmp(next, Headkin) && cmp(nextnext, Headkin)
				   && !cmp(Last, Tailkin))
				   || (cmp(current, Tailkin) 
                                   && cmp(nextnext, Headkin)
				   && !cmp(Last, Tailkin))){
					kungetc(KANJI);
					kungetc(KANJI);
					kungetc(KANJI);
					kaigyo();return NEWLINE;
				}else{
			      		kput(current);
					kungetc(KANJI);
					kungetc(KANJI);
					break;
				}	

			     }
			  }    

		}else if(Y_pos == Y_limit){
				if(cmp(current, Tailkin)
					&& !cmp(Last, Tailkin)){
					kungetc(KANJI);
					 kaigyo();return NEWLINE;
				}else{
				     if((c2 = kgetc(next)) == EOF) return EOF;
				     else if( c2 == KANJI ){
					if(cmp(next, Headkin) 
					   && !cmp(current, Headkin)){
						kungetc(KANJI);
						kungetc(KANJI);
					         kaigyo();return NEWLINE;
					}else{
						kungetc(KANJI);
					}
				     }else{
						kungetc(ASCII);
				     }				

				}
		}else if((Options & SERIFU) && (Y_pos !=  St_y)){
				 if(cmp(current, Serifu_begin)
					&& !cmp(Last, Indent)
					&& !cmp(Last, Tailkin)){
					kungetc(KANJI);
					 kaigyo();return NEWLINE;
				 }else if(cmp(current, Serifu_end)){
						kput(current);
				     if((c2 = kgetc(next)) == EOF) return EOF;
				     else if( c2 == KANJI 
					      && cmp(next, Headkin)){
             					kungetc(KANJI);
						break;
				     }else{
						if(c2 == KANJI) kungetc(KANJI);
						else kungetc(ASCII);

					if(Options & KEISEN){
						if(Y_pos+2 <= Y_limit){
						  locate(X_pos, Y_pos+2);
							 kaigyo();
						}
					}else{ 
						if(Y_pos+1 <= Y_limit){
						  locate(X_pos, Y_pos+1);
						 kaigyo();
						}
					}
				        return NEWLINE;
				     }
				 }
		}

			kput(current);
			break;

		default : /* impossible */ ; 
        }
}
 
locate(x, y)
int x, y;
{
	printf("%c[%d;%dH", ESC, y, x);
}

clstxt(flag)
int flag;
{
	if(flag == ALL)
		printf("%c[2J", ESC);
	else if(flag == CLS_TAIL)
		printf("%c[0J", ESC);
}

prompt()
{
	int c, cpage;
	char buf[KETA_SU]; 
	static JC s_str[S_STR_SIZE];
	static int errflag, c2;


	if( errflag == ON ){
	  locate(1, Max_l);
	 clstxt(CLS_TAIL);
	  printf("Not found.");
	}

	if(S_mode == ON && errflag == OFF){
	  locate(1, Max_l);
	 clstxt(CLS_TAIL);
	  printf("%c[%s]", c2,s_str);
	}

	locate(Max_c/2 - 3 + Offset, Max_l);
	printf("- %d/%d -  ", Page,Maxpage);

	/* Locate cursor to searched string */
	if(S_mode == ON && errflag == OFF) locate(S_x + Offset, S_y);

	c = getchar(); 

	if(c == 'q' || c == 'Q' || c ==  ESC){
		clstxt(ALL); return QUIT;
	}else if(c == 'p' || c == 'P' || c == BACK_SPACE){
		errflag = OFF;
		S_mode = OFF;
		Page--;
	}else if(c >= '0' && c <= '9'){
		int i = 0;
		buf[i++] = c;	
		while( (c = getchar()) >= '0' && c <= '9' && i < KETA_SU )
			buf[i++] = c;
		buf[i] = '\0';
		Page = atoi(buf);
		S_mode = OFF;
	}else if(c == 'E' || c == 'e'){
		errflag = OFF;
		S_mode = OFF;
		Page=Maxpage;	
	}else if(c == '/' || c == '?'){
		int i = 0;
		c2 = c; S_mode = ON; errflag = OFF;
		S_ptr = -1L;
    		  locate(1, Max_l);
		  clstxt(CLS_TAIL);
		if(c2 == '/') printf("/");
		else  printf("?");

			while( (c = getchar()) != LF && i< S_STR_SIZE ){
				if( c == BACK_SPACE ){
					if(i >= 1) s_str[--i] = '\0';
					if(i >= 1 && iskanji(s_str[i-1]))
						 s_str[--i] = '\0';
				}else{ s_str[i++] = (JC)c; s_str[i] = '\0';}

				 locate(1, Max_l);
		  		clstxt(CLS_TAIL);
				if(c2 == '/') printf("/");
				else  printf("?");
				  printf("%s", s_str);
			}

		cpage = Page;
		if( c2 == '/' ){
			Page = do_search(s_str, FORWARD);
			if(Page == NOT_FOUND){ errflag = ON; Page = cpage;}
		}else{
			Page = do_search(s_str, REVERSE);
			if(Page == NOT_FOUND ){ errflag = ON; Page = cpage;}
		}

	}else if(c == 'n'){
		errflag = OFF;
		S_mode = ON;
		cpage = Page;
		if( c2 == '/' ) Page = do_search(s_str, FORWARD);
		else  Page = do_search(s_str, REVERSE);
		if(Page == NOT_FOUND){ errflag = ON; Page = cpage;}
	}else if(c == 'N'){
		errflag = OFF;
		S_mode = ON;
		cpage = Page;
		if( c2 == '/' ) Page = do_search(s_str, REVERSE);
		else Page = do_search(s_str, FORWARD);
		if(Page == NOT_FOUND){ errflag = ON; Page = cpage;}
	}else{	
		errflag = OFF;
		S_mode = OFF;
		Page++;
	}

	if(Page < 1)       Page = 1;
	if(Page > Maxpage) Page = Maxpage;

	if(Options & KEISEN)kcls();
	else clstxt(ALL);

	fseek(Fpi, P_ary[Page], SEEK_SET);
	return (!QUIT);
}

usage()
{
printf("\n\tUsage: vtp [-g] [-o] [-k] [-s] [-z] [-Wnn] [-Hnn] filename\n");
printf("\t -g : ep̖ڂJISrfЂŕ`.\n");
printf("\t -o : _, i̒O, ƗsȊỎs𖳎sǂ.\n");
printf("\t -k : sLo͂.\n");
printf("\t -s : bʂň͂܂ꂽZtƗsɂ(p).\n");
printf("\t -z : ppSpɕϊ.\n");
printf("\t -Wnn : ʉ𔼊p[nn]ɂ.\n");
printf("\t -Hnn : ʏc[nn]sɂ.\n");
printf("\t======== co`fdq(vtp V2.2 for Kterm) =====\n");
printf("\t>>>>>>>> KEY̊蓖 <<<<<<<<<<<<<<<<<<<<<<<<<<<<\n");
printf("\tI        : Q, q, ESC.\n");
printf("\t        : E, e.\n");
printf("\tCӂ̕    : [0-9]+ {lȊOKEY.( 123G)\n");
printf("\tT: ?.\n");
printf("\tT: /.\n");
printf("\t(t)T  : n(N).\n");
printf("\tO        : P, p, BS.\n");
printf("\t        : SPACE, LȊOKEY.\n");
printf("\t===================================================\n");
#ifdef EUC
printf("\tFor EUC KANJI_CODE.\n");
#else /* default SHIFT_JIS */
printf("\tFor SHIFT_JIS KANJI_CODE.\n");
#endif
#ifdef OASYS
printf("\tOASYS r version.\n");
#endif
printf("\t  Copyright (c) Fukai Yoshiharu 1996.07.13\n");
printf("\t               <PED00251@niftyserve.or.jp>\n");
}

kdraw()
{
int x, y;
  for(x = 1;x <= Max_c-1;x+=2)
	for(y = 1;y <= Max_l;y+=1){
		locate(x+Offset, y);
#ifdef OASYS
		if(x == 1 && y == 1) kput("");

		if(x >= 3 && x <= Max_c-3 && y == 1 ){
			(x%4 == 3)? kput(""):kput("");
		}
		if(x >= 3 && x <= Max_c-3 &&  y == Max_l-1){
			(x%4 == 3)? kput(""):kput("");
		}
		if(x == Max_c - 1 && y == 1) kput("");

		if(x == 1  && y >= 2 && y <=  Max_l - 2) {
			(y%2 == 0)? kput(""): kput("");
		}
		if( x == Max_c-1 && y >= 2 && y <=  Max_l - 2) {
			(y%2 == 0)? kput(""): kput("");
		}

		if(x == 1 && y == Max_l-1) kput("");
		if(x == Max_c-1 && y == Max_l-1) kput("");

		if(x >= 3 && x <= Max_c -3 && y >= 2 && y <=  Max_l-2){
			if(y%2 == 0 ){ x%4 == 3 ? kput("  "):kput("");}
			else { x%4 == 3 ? kput(""):kput("");}
		
		}
#else
		if(x == 1 && y == 1) kput("");

		if(x >= 3 && x <= Max_c-3 && y == 1 ){
			(x%4 == 3)? kput(""):kput("");
		}
		if(x >= 3 && x <= Max_c-3 &&  y == Max_l-1){
			(x%4 == 3)? kput(""):kput("");
		}
		if(x == Max_c - 1 && y == 1) kput("");

		if(x == 1  && y >= 2 && y <=  Max_l - 2) {
			(y%2 == 0)? kput(""): kput("");
		}
		if( x == Max_c-1 && y >= 2 && y <=  Max_l - 2) {
			(y%2 == 0)? kput(""): kput("");
		}

		if(x == 1 && y == Max_l-1) kput("");
		if(x == Max_c-1 && y == Max_l-1) kput("");

		if(x >= 3 && x <= Max_c -3 && y >= 2 && y <=  Max_l-2){
			if(y%2 == 0 ){ x%4 == 3 ? kput("  "):kput("");}
			else { x%4 == 3 ? kput(""):kput("");}
		
		}
#endif
  	}
}

kcls()
{
int x_pos, y_pos;
		for (x_pos =  St_x ; x_pos >= X_limit ; x_pos -= Step_x){
		      for(y_pos = St_y ; y_pos <= Y_limit ; y_pos += Step_y){
				locate(x_pos + Offset, y_pos);
				kput("  ");
		      }
		 }
	locate( 1, Y_limit + 2);
	 clstxt(CLS_TAIL);

}

kgetc(buf)
JC buf[];
{
	int c;	

	buf[2] = '\0';

if( S_mode == ON && S_ptr == ftell(Fpi)){ S_x = X_pos; S_y = Y_pos; } 

  if((c = getc(Fpi)) == EOF){
	 return EOF;
  }else if(iskanji(c)){
	buf[0] = (JC)c;  
      if((c = getc(Fpi)) == EOF){ return EOF; }
	buf[1] = (JC)c;  
	return KANJI;
  }else if( c == LF ){
	buf[0] = (JC)c;  
	buf[1] = '\0';  
	return NEWLINE;
  }else if( c == TAB ){
	buf[0] =  ' ';  
	buf[1] = '\0';  
	return ASCII;
  }else{ 
	if( (Options & HAN2ZEN) && (c >= '!' && c <= '~') ){ 
		buf[0] = *Zenkaku[c - '!'];
		buf[1] = *(Zenkaku[c - '!']+1);
	}else{
		buf[0] = (JC)c;  
		buf[1] = '\0';  
	}
	return ASCII;
  }
   
}

kput(buf)
JC buf[];
{
   if(Dispsw == ON){ printf("%-2.2s", buf);}
	
	  Last[0] = buf[0];
	  Last[1] = buf[1];
}

kungetc(c)
int c;
{
	 if(c == KANJI)
	fseek(Fpi, -2L, SEEK_CUR);
	else if(c == ASCII)
	fseek(Fpi, -1L, SEEK_CUR);
}
cmp(buf, ary)
JC buf[];
JC *ary[];
{
 int i;
	for(i = 0;ary[i] != NULL ; i++){
		if(strcmp(buf, ary[i]) == 0) return 1;
	}
  return 0;
}

islastcr()
{
    if(Page == 1 && Y_pos == St_y
	       && X_pos == St_x) return 1;
	if(fseek(Fpi, -2L, SEEK_CUR)) return 1;
	else if(getc(Fpi) == LF){
		getc(Fpi);
		return 1;
	} else{
       		getc(Fpi);
		 return 0;
	}
}

kaigyo()
{
   if(Dispsw == ON && (Options & KMARK)) printf("%s", "");
}

binary_search(x,  a, left, right)
long x, a[]; int left, right;
{
	int mid;
	right++;
	while (left < right) {
		mid = (left + right) / 2;
		if (a[mid] <= x) left = mid + 1;  else right = mid;
	}
 	return left - 1;
}

do_search(str, mode)
JC str[];
int mode;
{
	static long last_S_ptr;
	static int last_type;
	long pos;
	int c,j=0;
	int k1;	
  if( mode == FORWARD ){
	if(S_ptr >= P_ary[Page] && S_ptr < P_ary[Page +1]){
        	if(last_type == KANJI) pos = S_ptr + 2L;
		else pos = S_ptr + 1L;
        }else{ pos = P_ary[Page]; S_ptr = P_ary[Page] - 1L;}

	 if(iskanji(str[0])) last_type = KANJI;
	 else last_type = ASCII;

	fseek(Fpi, pos, SEEK_SET);
	last_S_ptr = S_ptr;

	S_ptr = ftell(Fpi); k1 = OFF;
	while(( c = getc(Fpi)) != EOF && str[j] != '\0'){
			if(k1 == OFF){
				if( iskanji(c) ) k1 = ON;
			}else{ k1 = OFF;}

	    if( c == '\n' ){
		if( j == 0 ) S_ptr = ftell(Fpi);
		 continue;
	    }else if( (JC)c == str[j] ) j++;
	    else {
		j = 0;
		if( k1 == ON ){ getc(Fpi); k1 = OFF;}
		S_ptr = ftell(Fpi);
	    }

		if(last_S_ptr < S_ptr && str[j] == '\0'){
			return binary_search( S_ptr, P_ary, Page, Maxpage);
		}
	}

  }else if( mode == REVERSE ){
	int i = 0;
	F_flag = OFF;

	 if(!(S_ptr <= P_ary[Page+1] && S_ptr >= P_ary[Page]))
		S_ptr = P_ary[Page+1];

	last_S_ptr = S_ptr;

	do{
		pos = P_ary[Page + i];
		fseek(Fpi, pos, SEEK_SET);
		j=0; k1 = OFF;
		while(( c = getc(Fpi)) != EOF && pos < P_ary[Page + i + 1]){
			if(k1 == OFF){
				if( iskanji(c) ) k1 = ON;
			}else{ k1 = OFF;}

		    if( c == '\n' ){
			if( j == 0 ) pos = ftell(Fpi);
			 continue;
		    }else if( (JC)c == str[j] ) j++;
		    else {
			j = 0;
			if( k1 == ON ){ getc(Fpi); k1 = OFF;}
			pos = ftell(Fpi);
		    }

			if( pos < last_S_ptr && str[j] == '\0'){/* FOUND */
				j=0;
				F_flag = ON;
				S_ptr = pos;
				pos = ftell(Fpi);
			}
		}
		if ( F_flag == ON ){
			last_S_ptr = S_ptr;
			return binary_search( S_ptr, P_ary, 1, Page + 1 );
		}
			i--;
	}while(Page + i >= 1 );

  }
	F_flag = OFF; S_ptr = -1L;
	return NOT_FOUND;
}


bookmarkptr add_book(p, fname, pos)
bookmarkptr p;
char *fname;
long pos;
{
	int cmp;
	if (p == NULL){
		if( (p = (bookmarkptr)malloc(sizeof(*p))) == NULL){
			printf("mem short!!.\n");  exit();
		}
		if( (p->fname = (char *)malloc(strlen(fname)+1)) == NULL){
			printf("mem short!!.\n");  exit();
		}
		strcpy(p->fname, fname);
		p->pos = pos;
		p->left =  p->right = NULL;
	}else if((cmp = strcmp(p->fname,fname)) < 0)
		p->right = add_book(p->right,fname,pos);
	else 
		p->left = add_book(p->left,fname,pos);
	return (p);
		
}

printbook(bookmarkptr p)
{
	if (p != NULL){
		printbook(p->left);
		fprintf(Fpb,"%s %ld\n",p->fname,p->pos);
		printbook(p->right);
	}
}

read_book()
{
	char buf[256];
	long pos, kp = 0L;
	 if((Fpb = fopen(Bname, "r")) == 0){
		locate(1,1);
		printf("Create %s.\n", Bname);
	 }else{
		while(fscanf(Fpb,"%s%ld",buf,&pos) != EOF){
		   if( strcmp(buf,Fname) == 0){
			 kp = pos;
			 continue;
		   }
			 Anchor = add_book(Anchor,buf,pos);
		}
		fclose(Fpb);
	}
	return binary_search( kp, P_ary, 1, Maxpage);
}

